From 8aa295016865c9c9f8ad25e2519474fa75100e18 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Wed, 22 Jul 2020 16:12:52 +0200
Subject: [PATCH] replace dedicated clear float tags by ".clearfix" class
 (#45365)

---
 templates/authentic2/login.html                           | 3 +--
 templates/variants/chaumontgistoux/authentic2/login.html  | 3 +--
 templates/variants/imio-pwa-2020/authentic2/accounts.html | 1 -
 templates/variants/imio-pwa-2020/authentic2/login.html    | 3 +--
 templates/variants/liege-pwa-2019/authentic2/login.html   | 3 +--
 templates/variants/liege/authentic2/accounts.html         | 3 +--
 templates/variants/montsaintguibert/authentic2/login.html | 3 +--
 templates/variants/verviers/authentic2/login.html         | 3 +--
 templates/variants/wallonieconnect/authentic2/login.html  | 3 +--
 9 files changed, 8 insertions(+), 17 deletions(-)

diff --git a/templates/authentic2/login.html b/templates/authentic2/login.html
index 9663e50..d5361f0 100644
--- a/templates/authentic2/login.html
+++ b/templates/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-<div id="login-page">
+<div id="login-page" class="clearfix">
 
 <p>
 Pour accéder aux démarches sécurisées, veuillez vous connecter :
@@ -31,7 +31,6 @@ Pour accéder aux démarches sécurisées, veuillez vous connecter :
 {{blocks.password.content|safe}}
 </div>
 
-<br class="clear"/>
 </div>
 
 
diff --git a/templates/variants/chaumontgistoux/authentic2/login.html b/templates/variants/chaumontgistoux/authentic2/login.html
index ffe2e1e..3e81c31 100644
--- a/templates/variants/chaumontgistoux/authentic2/login.html
+++ b/templates/variants/chaumontgistoux/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-<div id="login-page">
+<div id="login-page" class="clearfix">
 
 <p>
 Pour accéder aux démarches sécurisées, veuillez vous connecter :
@@ -29,7 +29,6 @@ Pour accéder aux démarches sécurisées, veuillez vous connecter :
 {{blocks.password.content|safe}}
 </div>
 
-<br class="clear"/>
 </div>
 
 
diff --git a/templates/variants/imio-pwa-2020/authentic2/accounts.html b/templates/variants/imio-pwa-2020/authentic2/accounts.html
index bd197a6..f15d313 100644
--- a/templates/variants/imio-pwa-2020/authentic2/accounts.html
+++ b/templates/variants/imio-pwa-2020/authentic2/accounts.html
@@ -85,5 +85,4 @@
   {% block account-management-post %}{% endblock %}
 </div>
 {% endif %}
-<br class="clear" />
 {% endblock %}
diff --git a/templates/variants/imio-pwa-2020/authentic2/login.html b/templates/variants/imio-pwa-2020/authentic2/login.html
index 4f92bfd..01ec8fb 100644
--- a/templates/variants/imio-pwa-2020/authentic2/login.html
+++ b/templates/variants/imio-pwa-2020/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-<div id="login-page">
+<div id="login-page" class="clearfix">
 
 {% block login %}
 <div id ="wca-login-box">
@@ -33,7 +33,6 @@
 </div>
 {% endblock %}
 
-<br class="clear"/>
 </div>
 
 
diff --git a/templates/variants/liege-pwa-2019/authentic2/login.html b/templates/variants/liege-pwa-2019/authentic2/login.html
index af40bbb..b02e496 100644
--- a/templates/variants/liege-pwa-2019/authentic2/login.html
+++ b/templates/variants/liege-pwa-2019/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-<div id="login-page">
+<div id="login-page" class="clearfix">
 
 <p>
 Pour accéder aux démarches sécurisées, veuillez vous connecter :
@@ -38,7 +38,6 @@ Pour accéder aux démarches sécurisées, veuillez vous connecter :
 </div>
 {% endif %}
 
-<br class="clear"/>
 </div>
 
 
diff --git a/templates/variants/liege/authentic2/accounts.html b/templates/variants/liege/authentic2/accounts.html
index 97804de..37f2344 100644
--- a/templates/variants/liege/authentic2/accounts.html
+++ b/templates/variants/liege/authentic2/accounts.html
@@ -64,8 +64,7 @@
   </div>
   {% endfor %}
 </div>
-<br class="clear" />
-<div id="footer-text">
+<div id="footer-text" style="clear:both">
 Pour compléter les champs non spécifiés du compte, cliquez sur ce lien : "<a
 href="{% url 'profile_edit' %}">Éditer les données du compte</a>" ou dans la colonne : "Gestion du compte".
 </div>
diff --git a/templates/variants/montsaintguibert/authentic2/login.html b/templates/variants/montsaintguibert/authentic2/login.html
index 7a23c09..dad8796 100644
--- a/templates/variants/montsaintguibert/authentic2/login.html
+++ b/templates/variants/montsaintguibert/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-<div id="login-page">
+<div id="login-page" class="clearfix">
 
 <p>
 Pour accéder aux démarches sécurisées, veuillez vous connecter :
@@ -32,7 +32,6 @@ Pour accéder aux démarches sécurisées, veuillez vous connecter :
 {{blocks.password.content|safe}}
 </div>
 
-<br class="clear"/>
 </div>
 
 
diff --git a/templates/variants/verviers/authentic2/login.html b/templates/variants/verviers/authentic2/login.html
index 109a234..1056afe 100644
--- a/templates/variants/verviers/authentic2/login.html
+++ b/templates/variants/verviers/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-<div id="login-page">
+<div id="login-page" class="clearfix">
 
 <p>
 Pour accéder aux démarches sécurisées, veuillez vous connecter.
@@ -33,7 +33,6 @@ Pour accéder aux démarches sécurisées, veuillez vous connecter.
 {{blocks.password.content|safe}}
 </div>
 
-<br class="clear"/>
 </div>
 
 
diff --git a/templates/variants/wallonieconnect/authentic2/login.html b/templates/variants/wallonieconnect/authentic2/login.html
index 52c16d2..a440383 100644
--- a/templates/variants/wallonieconnect/authentic2/login.html
+++ b/templates/variants/wallonieconnect/authentic2/login.html
@@ -14,7 +14,7 @@
 
 {% block content %}
 
-  <div id="login-page">
+  <div id="login-page" class="clearfix">
 
   {% block login %}
   <div id="what_is_wc">
@@ -36,7 +36,6 @@
 
   {% endblock %}
 
-  <br class="clear"/>
   </div>
 
 {% endblock %}
-- 
2.20.1